{

T is 1/3 500 000

Pilot halfperiod is 2168 * T
0 halfperiod is 855 * T
1 halfperiod is 1710 * T

so pilot halfperiod is 6.8 samples
0 halfperiod is 2.6 samples
1 halfperiod is 5.3 samples

}

{$define NDEBUG}

Const
HPPilot = 6;
HPPilotMax = 8;
HPPilotMin = 5;

HP0 = 2;
HP0Max = 4;
{HP0Max = 4;}
HP0Min = 1;
HP1 = 5;
HP1Max = 7;
HP1Min = 4;


MINPILOTPERIODS = 200;

Type HEADER = Record
               Flag : Byte;
               DType : Byte;
               Name : Array[0..9] Of Byte;
               Len : Word;
               Param1,
               Param2 : Word;
               ChekSum : Byte;
              End;

Var
 F : File;
 O : File;
 B : Array[0..4095] Of Byte;
 BPos : Word;
 BlokSize : Word;
 BlockDat : Array[0..59999] Of Byte;
 BlockPos : Word;
 TH : HEADER;

Procedure HaltX;
 Begin
  Close(F);
  Close(O);
  Halt(1);
 End;

Procedure WaveOpen(FN:String);
 Begin
  Assign(F,FN);
  Reset(F,1);
  Seek(F,44); { skip wave header }
  BPos:=4096;
  BlokSize:=4096;
 End;

Function WaveGetRaw:Byte;
 Begin
  If BPos = BlokSize
     Then Begin
           If BlokSize<>4096
              Then Begin
                    WriteLn('Tape end');
                    HaltX;
                   End;
           BlockRead(F,B,4096,BlokSize);
           BPos:=0;
          End;
  WaveGetRaw := B[BPos];
  Inc(BPos);
 End;

Function WaveGetCooked:Boolean;
 Begin
  WaveGetCooked := WaveGetRaw>=128;
 End;

Procedure WaveClose;
 Begin
  Close(F);
 End;

Function IsAbout(Lo,Hi,Min,Max:LongInt):Boolean;
 Begin
  {$IFDEF DEBUG}
  Write('[',Lo,',',Hi,']');
  {$ENDIF}
  If (Lo >= Min) And (Lo <= Max) And
     (Hi >= Min) And (Hi <= Max)
     Then Begin
           IsAbout := True;
          End
     Else Begin
           IsAbout := False;
           {$IFNDEF DEBUG}
           {Write('[',Lo,',',Hi,']');}
           {$ENDIF}
          End;
 End;

Var LoCnt,
    HiCnt : LongInt;
    LastS,
    NewS : Boolean;
    LastHi,
    LastLo:LongInt;

Procedure DetectEdge;
 Var EdgeEnd : Boolean;
 Begin
  EdgeEnd := False;
  Repeat
   NewS := WaveGetCooked;
   If NewS = Not LastS
      Then Begin { edge! }
            {$IFDEF DEBUG}
            If NewS
               Then Write('/')
               Else Write('\');
            {$ENDIF}
            EdgeEnd := True;
            LastHi := HiCnt;
            LastLo := LoCnt;
            If NewS
               Then HiCnt := 0
               Else LoCnt := 0;
           End;
   If NewS
      Then Inc(HiCnt)
      Else Inc(LoCnt);
   LastS := NewS;
  Until EdgeEnd;
 End;

Procedure WaitForPilot;
 Begin
  While Not IsAbout(LastLo,LastHi,HPPilotMin,HPPilotMax) Do
        DetectEdge;
{  WriteLn('pilot start');}
 End;

Procedure WaitTillPilot;
 Var
     PilotEnd : Boolean;
     PilotCnt : LongInt;
 Begin
  WaitForPilot;
  PilotEnd := False;
  PilotCnt := 0;
  Repeat
   DetectEdge;
   If Not IsAbout(LastLo,LastHi,HPPilotMin,HPPilotMax)
      Then Begin
            { another edge }
            DetectEdge;
            If IsAbout(LastLo,LastHi,1,3) And
               (PilotCnt > MINPILOTPERIODS)
               Then PilotEnd:=True
               Else Begin
                     Write('p!');
                     PilotCnt := 0;
                     WaitForPilot;
                    End;
           End
      Else Begin
            Inc(PilotCnt);
           End;
  Until PilotEnd;

 End;

Var IsError : Boolean;

Function LoadByte:Byte;
 Var BitCtr : Byte;
     B : Byte;

 Begin
  B:=0;
  For BitCtr:=1 To 8 Do
      Begin
       DetectEdge;
       DetectEdge;
       If IsAbout(LastLo,LastHi,HP0Min,HP0Max)
          Then Begin
                {$IFDEF DEBUG}
                WriteLn('0');
                {$ENDIF}
                B:=B SHL 1;
               End
          Else Begin
                If IsAbout(LastLo,LastHi,HP1Min,HP1Max)
                   Then Begin
                         {$IFDEF DEBUG}
                         WriteLn('1');
                         {$ENDIF}
                         B := (B SHL 1) + 1;
                        End
                   Else Begin
                         {WriteLn('Tape loading error! 0:1');}
                         IsError:=True;
                        End;

               End;
      End;
  LoadByte:=B;
 End;

Procedure ReadBlock;
 Var B : Byte;
     Chek : Byte;
     I : Integer;
     C : Char;
 Begin
  IsError:=False;
  BlockPos := 0;
  WaitTillPilot;
  WriteLn;
  Chek := 0;
  Repeat
   B:=LoadByte;
   If IsError
      Then Begin
            If Chek<>0
               Then Begin
                     Write('Block error at ',BlockPos,' repair ?');
                     ASM
                      XOR AH,AH
                      INT 16H
                      MOV C,AL
                     End;
                     WriteLn(UpCase(C));
                     If UpCase(C)='Y'
                        Then Begin
                              B:=BlockDat[BlockPos-1];
                              ASM
                               MOV AL,B
                               XOR Chek,AL
                              End;
                              BlockDat[BlockPos-1]:=Chek;
                              Chek:=0;
                             End;
                    End;
            If Chek=0
               Then Begin
                     BlockWrite(O,BlockPos,2);
                     BlockWrite(O,BlockDat,BlockPos);
                     If (BlockDat[0] = 0)
                        Then Begin
                              Move(BlockDat,TH,19);
                              Write('Header:',TH.Len,' Name:');
                              For I:=0 To 9 Do Write(Char(TH.Name[I]));
                              WriteLn;
                             End;
                     WriteLn('Len was:',BlockPos);
                     Exit;
                    End
               Else Begin
                     WriteLn('Tape loading error.');
                     HaltX;
                    End;
           End;
   If BlockPos=0
      Then WriteLn('Block type:',B);
   BlockDat[BlockPos]:=B;
   Inc(BlockPos);
   asm
    MOV  AL,B
    XOR  Chek,AL
   End;
   {$IFDEF DEBUG}
   WriteLn(':',B,':');
   {$ENDIF}
  Until False;
 End; { read block }

Begin
 LoCnt := 0;
 HiCnt := 0;
 WaveOpen(ParamStr(1));
 Assign(O,ParamStr(2));
 ReWrite(O,1);
 Repeat
  ReadBlock;
 Until False;
 WaveClose;
 Close(O);
End.


